import logging

with MagicFinder(colorlog='colorlog'):
	from colorlog import ColoredFormatter


class StripExcFilter:
	def filter(self, record):
		record.exc_info = None
		return True

# Logger for any of the startup scripts
startup_logger = logging.getLogger('startup')


# Initialise logging with a pretty formatter
handler = logging.StreamHandler()
handler.setFormatter(ColoredFormatter(
	"%(log_color)s%(levelname)7s%(reset)s: [%(name)s] %(log_color)s%(message)s",
))
logging.root.addHandler(handler)
logging.root.setLevel(logging.DEBUG)

# Supress DEBUG from tab-completion parser
logging.getLogger('parso').setLevel(logging.INFO)

# Strip exc-info from curio.kernel messages; we don't need to see the internals
# of the kernel
logging.getLogger('curio.kernel').addFilter(StripExcFilter())

del ColoredFormatter
del handler
