. ~/.shell/lib/strings.bash

_input_completion() {
	local prefix=${READLINE_LINE:0:$READLINE_POINT}
	local suffix=${READLINE_LINE:$READLINE_POINT}
	local host
	declare -a comp=()

	tput -S <<-END
		sc
		ed
	END

	for host in "$@"; do
		if [[ ! $prefix || $host =~ ^"$prefix" ]] && [[ ! $suffix || $host =~ "$suffix" ]]; then
			echo $host
		fi
	done |
	sort -u |
	read -d '' -a comp || true

	case ${#comp[*]} in
		0) return ;;
		1) READLINE_LINE=${comp[0]} READLINE_POINT=${#READLINE_LINE}; return ;;
	esac

	tput -S <<-END
		cud1
		cud1
		setaf 4
		bold
	END
	printf "%s\n" "${comp[@]}" | column
	tput -S <<-END
		sgr0
		rc
	END

	local new_prefix=$(common_prefix "${comp[@]}")
	local new_suffix=$(common_suffix "${comp[@]}")

	[[ -n $new_prefix ]] && prefix=$new_prefix
	[[ -n $new_suffix ]] && suffix=$new_suffix

	READLINE_LINE="${prefix}${suffix}"
	READLINE_POINT=${#prefix}
}

# Usage: read_completions "Prompt" [OUT_VAR ...] [-- [COMPLETION ...]]
read_completions() {
	local IFS=' '
	local prompt=$1
	declare -a out
	while [[ -v 2 && $2 != -- ]]; do out+=($2); shift; done;
	shift 2
	bind -x '"\t"':"_input_completion $*"
	unset IFS
	trap 'bind -r "\t"' RETURN
	read -e -p "$prompt: " "${out[@]}"
}
