# Needs Git plugin for current_branch method

# Color shortcuts
RED=$fg[red]
YELLOW=$fg[yellow]
GREEN=$fg[green]
WHITE=$fg[white]
BLUE=$fg[blue]
RED_BOLD=$fg_bold[red]
YELLOW_BOLD=$fg_bold[yellow]
GREEN_BOLD=$fg_bold[green]
WHITE_BOLD=$fg_bold[white]
BLUE_BOLD=$fg_bold[blue]
RESET_COLOR=$reset_color

HOST_COLOUR=$'\e[1;'${PROMPTCOLOUR}m

# Format for git_prompt_info()
ZSH_THEME_GIT_PROMPT_PREFIX=""
ZSH_THEME_GIT_PROMPT_SUFFIX=""

# Format for parse_git_dirty()
ZSH_THEME_GIT_PROMPT_DIRTY=" %{$RED%}(*)"
ZSH_THEME_GIT_PROMPT_CLEAN=""

# Format for git_prompt_status()
ZSH_THEME_GIT_PROMPT_UNMERGED=" %{$RED%}unmerged"
ZSH_THEME_GIT_PROMPT_DELETED=" %{$RED%}deleted"
ZSH_THEME_GIT_PROMPT_RENAMED=" %{$YELLOW%}renamed"
ZSH_THEME_GIT_PROMPT_MODIFIED=" %{$YELLOW%}modified"
ZSH_THEME_GIT_PROMPT_ADDED=" %{$GREEN%}added"
ZSH_THEME_GIT_PROMPT_UNTRACKED=" %{$WHITE%}untracked"

# Format for git_prompt_ahead()
ZSH_THEME_GIT_PROMPT_AHEAD=" %{$RED%}(!)"

# Format for git_prompt_long_sha() and git_prompt_short_sha()
ZSH_THEME_GIT_PROMPT_SHA_BEFORE=" %{$WHITE%}[%{$YELLOW%}"
ZSH_THEME_GIT_PROMPT_SHA_AFTER="%{$WHITE%}]"

local tick=$'\xe2\x9c\x93'
local cross=$'\xe2\x9c\x97'

function prompt_context {
	declare -a contexts=()
	local IFS= sep=
	for ctx in "${(@kM)parameters:#CONTEXT_*}"; do
		contexts+=("$sep" "%{$GREEN_BOLD%}${${ctx#CONTEXT_}:l}:%{$YELLOW_BOLD%}${(P)ctx}")
		sep="%{$WHITE_BOLD%}|"
	done
	[ ${#contexts} -eq 0 ] && return
	print "%{$WHITE_BOLD%}[${contexts[*]}%{$WHITE_BOLD%}] "
}

# Prompt format
PROMPT='%{$PROMPTCODES%}%{$HOST_COLOUR%}%n@%m: $%{$RESET_COLOR%} '
RPROMPT='%(?:%{$GREEN_BOLD%}$tick:%{$RED_BOLD%}$? $cross) \
$(prompt_context)\
%{$RESET_COLOR%}'
