let g:TermToggleOpenNewWindow = 1
let g:TermToggleDebug = [ &shell ]
let s:hot_terms = {}
let s:debugger_term = {}

function s:toggle_debug()
	if get(s:debugger_term, 'closed', v:true)
		let s:debugger_term = kodo#toggleterm#Terminal(v:false, g:TermToggleDebug)
	endif
	call s:debugger_term.toggle()
endfunction

function s:toggle(num)
	if !has_key(s:hot_terms, a:num)
		let l:term = kodo#toggleterm#Terminal(v:false)
		let s:hot_terms[a:num] = l:term

		function! l:term.on_collapse()
			call self.close_window()
			unlet t:term_window
		endfunction
	else
		let l:term = s:hot_terms[a:num]
	endif
	if exists("t:term_window") && 0 != win_id2win(t:term_window)
		call l:term.toggle(t:term_window)
	else
		call l:term.expand(v:true)
		let t:term_window = l:term.window
	endif
endfunction

command        DebuggerTerm :call s:toggle_debug()
command -nargs=1 TermToggle :call s:toggle(<args>)

nnoremap <silent> <F5> <Esc>:DebuggerTerm<CR>
tnoremap <silent> <F5> <C-\><C-n>:DebuggerTerm<CR>

nnoremap <silent> <F6> <Esc>:TermToggle 0<CR>
tnoremap <silent> <F6> <C-\><C-n>:TermToggle 0<CR>

nnoremap <silent> <F7> <Esc>:TermToggle 1<CR>
tnoremap <silent> <F7> <C-\><C-n>:TermToggle 1<CR>

nnoremap <silent> <F8> <Esc>:TermToggle 2<CR>
tnoremap <silent> <F8> <C-\><C-n>:TermToggle 2<CR>
